#<profile4xi profile = "20" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "rawvalue4xi.py">
#<abstract4xi abstract = "providing function RawValue4Xi"/>
#<refer4xi reference = "sharedctypes.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------
 
# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'RawValue4Xi' ]
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import sys
import ctypes
import weakref
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:
    import _winapi
except:
    pass

                
try:                 # most-common ones
    pass        
except:
    pass
try:                 # rare ones
    pass         
except:
    pass 
try:                 # imported-as ones 
    pass          
except:
    pass            
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing.sharedctypes import RawValue
except:
    print("rawvalue4xi.py: *** failed in from multiprocessing.sharedctypes import RawValue ***")   
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from examine4xi import examine4xi 
from print4xi import print4xi
from time4xi import time4xi
from _new_value4xi import _new_value4xi
#"
#/>


# -------------------------------------------------------------------------------------------------
# Types                              
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/> 
# -------------------------------------------------------------------------------------------------
#
#<type4xi type = "
typecode_to_type = {
    'c': ctypes.c_char,  'u': ctypes.c_wchar,
    'b': ctypes.c_byte,  'B': ctypes.c_ubyte,
    'h': ctypes.c_short, 'H': ctypes.c_ushort,
    'i': ctypes.c_int,   'I': ctypes.c_uint,
    'l': ctypes.c_long,  'L': ctypes.c_ulong,
    'f': ctypes.c_float, 'd': ctypes.c_double}
#"

#usage = "
#    mapping Python types to to C-language types
#"
#>






# -------------------------------------------------------------------------------------------------
#<function4xi function = "RawValue4Xi" usage = "
#   sharedctypes.py
#       obj = RawValue(typecode_or_type, *args)
#   valuefunction4xi.py
#       object2xi = RawValue4Xi(typecode_or_type, *args)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def RawValue4Xi(typecode_or_type, *args):
    '''
    returns a ctypes object allocated from shared memory
    '''
    class2print = "RawValue4Xi"
    method2print = "RawValue4Xi"
      
    
    # -----------------------------------------------------------------------------------------    
    # (Step 1/5)
    # -----------------------------------------------------------------------------------------        
    message2print = "{(Step 1/5a) started" + "; RawValue4Xi-started: " + str(RawValue4Xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # <function RawValue4Xi at 0x0000000003A3D950> 
       
    message2print = "{(Step 1/5b) passed" + "; typecode-or-type-passed-to-typecode-to-type: " + str(typecode_or_type) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    # i
        
    if examine4xi(class2print, method2print):  
    
        # -------------------------------------------------------------------------------------    
        # StepOriginal
        # -------------------------------------------------------------------------------------             
        message2print = "{(Step 2/6b) performing" + "; RawValue-performing-by-RawValue4Xi: " + str(RawValue)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
                         
        return RawValue(typecode_or_type, *args)
        
    else:        
        type2xi = typecode_to_type.get(typecode_or_type, typecode_or_type)
        
        message2print = "{(Step 1/5d) set" + "; type2xi-set-by-RawValue4Xi to: " + str(type2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # <class 'ctypes.c_long'>
                 
        
        # -----------------------------------------------------------------------------------------    
        # (Step 2/5) - JATKA
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 2/5a) passing" + "; type2xi-passing-to-new-value4xi-by-RawValue4Xi: " + str(type2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # <class 'ctypes.c_long'>    
                
        obj2xi = _new_value4xi(type2xi)
        
        message2print = "{(Step 2/5b) set" + "; obj2xi-set-by-RawValue4Xi to: " + str(obj2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # c_long(0)
                    
        
        # -----------------------------------------------------------------------------------------    
        # (Step 3/5)
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 3/5a) passing" + "; ctypes-addressof-obj2xi-passing-to-ctypes-memset-by-RawValue4Xi: " + str(ctypes.addressof(obj2xi)) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # 31457280
        
        message2print = "{(Step 3/5b) passing" + "; 0-passing-to-ctypes-memset-by-RawValue4Xi: " + str(0) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        # 0
        
        message2print = "{(Step 3/5c) passing" + "; ctypes-sizeof-obj2xi-passing-to-ctypes-memset-by-RawValue4Xi: " + str(ctypes.sizeof(obj2xi)) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)              
        # 4
        
        ctypes.memset(ctypes.addressof(obj2xi), 0, ctypes.sizeof(obj2xi))
        
        message2print = "{(Step 3/5d) performed" + "; ctypes-memset-performed-by-RawValue4Xi: " + str(ctypes.memset) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <CFunctionType object at 0x0000000002AA8118>
                
        # -----------------------------------------------------------------------------------------    
        # (Step 4/5)
        # -----------------------------------------------------------------------------------------        
    
        obj2xi.__init__(*args)
        
        message2print = "{(Step 4/5) performed" + "; obj2xi-init-performed-by-RawValue4Xi: " + str(obj2xi.__init__) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
        # <method-wrapper '__init__' of c_long object at 0x0000000003AE1748>
              
        # -----------------------------------------------------------------------------------------    
        # (Step 5/5)
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 5/5) returning" + "; obj2xi-returning-by-RawValue4Xi: " + str(obj2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # c_long(7)   
    
        return obj2xi

#</function4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of rawvalue4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

